All of lore.kernel.org
 help / color / mirror / Atom feed
* [PATCH] btrfs: test quota disable during quota rescan
@ 2015-11-06 18:40 Justin Maggard
  2015-11-07 15:08 ` Filipe Manana
  0 siblings, 1 reply; 3+ messages in thread
From: Justin Maggard @ 2015-11-06 18:40 UTC (permalink / raw)
  To: fstests, linux-btrfs; +Cc: Justin Maggard

This test case tests if we are able to disable quotas on a filesystem
while a quota rescan is running.  Up to now (4.3) this would result
in a kernel NULL pointer dereference.

Fixed by patch (btrfs: qgroup: fix quota disable during rescan).

Signed-off-by: Justin Maggard <jmaggard@netgear.com>
---
 tests/btrfs/115     | 62 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/115.out |  2 ++
 tests/btrfs/group   |  1 +
 3 files changed, 65 insertions(+)
 create mode 100755 tests/btrfs/115
 create mode 100644 tests/btrfs/115.out

diff --git a/tests/btrfs/115 b/tests/btrfs/115
new file mode 100755
index 0000000..0d1cb3a
--- /dev/null
+++ b/tests/btrfs/115
@@ -0,0 +1,62 @@
+#! /bin/bash
+# FS QA Test No. btrfs/115
+#
+# btrfs quota scan/disable sanity test
+# Make sure that disabling quotas during a quota rescan doesn't crash
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2015 NETGEAR, Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+
+_scratch_mkfs >>$seqres.full 2>&1
+_scratch_mount
+
+for i in `seq 0 1 450000`; do
+	echo -n > $SCRATCH_MNT/file.$i
+done
+echo 3 > /proc/sys/vm/drop_caches
+$BTRFS_UTIL_PROG quota enable $SCRATCH_MNT
+$BTRFS_UTIL_PROG quota disable $SCRATCH_MNT
+
+
+echo "Silence is golden"
+status=0
+exit
diff --git a/tests/btrfs/115.out b/tests/btrfs/115.out
new file mode 100644
index 0000000..d9dd136
--- /dev/null
+++ b/tests/btrfs/115.out
@@ -0,0 +1,2 @@
+QA output created by 115
+Silence is golden
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 10ab26b..39b9aff 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -117,3 +117,4 @@
 112 auto quick clone
 113 auto quick compress clone
 114 auto qgroup
+115 auto qgroup
-- 
2.6.3


^ permalink raw reply related	[flat|nested] 3+ messages in thread

end of thread, other threads:[~2015-11-08 21:52 UTC | newest]

Thread overview: 3+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2015-11-06 18:40 [PATCH] btrfs: test quota disable during quota rescan Justin Maggard
2015-11-07 15:08 ` Filipe Manana
2015-11-08 21:51   ` Dave Chinner

This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.